package com.ic.constant;

import java.util.List;

import javax.annotation.PostConstruct;

import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ic.modules.auth.model.Templates;
import com.ic.modules.auth.service.TemplatesService;

@Service
public class TemplateConfig {
	private static JSONObject configs;
	private static final Logger LOG = LoggerFactory.getLogger(TemplateConfig.class);
	
	@Autowired 
	TemplatesService templatesService;
	
	@PostConstruct
    public void init() {
		refreshConfig();
    }
	
	public void refreshConfig() {
		List<Templates> templates = templatesService.findAll();
		configs = new JSONObject();
		for(Templates configuration : templates) {
			configs.put(configuration.getKey(), configuration.getValue());
		}
	}
	public String getValue(String key) {
			return configs.getString(key);
	}
	public void setValue(String key,String value) {
		if(configs.has(key)) {
			configs.put(key,value);
		}
	}

}