package com.ic.modules.auth.payload;

import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.ic.constant.RolesConstant;
import com.ic.constant.Status;
import com.ic.modules.auth.model.User;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

@Setter
@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
@ToString
@JsonInclude(Include.NON_NULL)
public class UserDto {

	private String id;
	
	@NotBlank
    private String name;

    @NotNull
    @Pattern(regexp="^[0-9]{10}",message="length must be 10")  
    private String mobileNumber;
    
    private String email;

    @Enumerated(EnumType.STRING)
    protected Status status = Status.ACTIVE;
    

    @NotNull
    @Enumerated(EnumType.STRING)
    private RolesConstant role; 

    private String notificationId;
    
    private int failedAttemptLogin = 0;

    public UserDto(User user) {
    	this.id = user.getUserId();
//    	this.status = user.getStatus();
    	this.name = user.getFirstName();
    	this.mobileNumber = user.getMobileNo();
    	this.email = user.getEmailId();
    	this.notificationId = user.getNotificationId();
    	this.failedAttemptLogin = user.getFailedAttemptLogin();
    	//this.role = user.getRole();
    }

}